0
1

Delete article

Deleted articles cannot be recovered.

Draft of this article would be also deleted.

Are you sure you want to delete this article?

More than 5 years have passed since last update.

SketchUp Make v17 / Ruby > 立方体をずらすスクリプト (半手動版)

Last updated at Posted at 2016-12-24
動作環境
SketchUp Make v17.1.173
MacOS X El Capitan

http://qiita.com/7of9/items/806f287f032e600b2fcd
にて検討していた、立方体をずらす方法。

手動手順の検討 http://qiita.com/7of9/items/c2eee027ef307fe26b54

v0.1 半手動版

code

簡易版(半手動)を実装できた。 

test161224.rb
require 'sketchup.rb'

def dokodoko(distance)
	model = Sketchup.active_model
	selection = model.selection.to_a
	faces = selection.grep(Sketchup::Face)

	flag = 0
	faces.each do |face|
		if flag == 0 then
			face.pushpull(distance)
			flag = 1
		else
			face.pushpull(-distance)
			break
		end
	end
end

使い方

http://qiita.com/7of9/items/ff5921cf65b5f88d9311#_reference-0b70faed1275d8553793
に記載のフォルダに上記のrbファイルを置く。

Rubyコンソールにて以下でスクリプトを読込む。

>load "test161224.rb"
true

ずらしたい立方体の「前面」と「後面」を選択する。

Rubyコンソールで以下のようにする。
(100.mmは移動距離)

> > dokodoko(100.mm)

移動例1

移動前
(この例では左側の面とその反対の面を選択してからdokodokoする)

qiita.png

移動後

qiita.png

移動例2

以下の形状の真ん中をずらしてみた。

qiita.png

qiita.png

あとはくっついている平面を削除して、移動された立方体をグループ化すると、個別のパーツとして扱うことができるようになる。

0
1
0

Register as a new user and use Qiita more conveniently

  1. You get articles that match your needs
  2. You can efficiently read back useful information
  3. You can use dark theme
What you can do with signing up
0
1

Delete article

Deleted articles cannot be recovered.

Draft of this article would be also deleted.

Are you sure you want to delete this article?